%%-----------------------------------------------------------------------------
%% module  :       void_fam
%% @author  :       Czc
%% email   :       389853407@qq.com
%% Created :       2017-11-15
%% description:    无尽领域头文件
%%-----------------------------------------------------------------------------

-define(P_ROLE_MAP, "P_ROLE_MAP").                                      %% 保存在进程字典的参与活动的玩家Map

-define(P_ROLE_RANK, "P_ROLE_RANK").

-define(P_ACHIEVE_FLOOR_RECORD_MAP, "P_ACHIEVE_FLOOR_RECORD_MAP").      %% 进入楼层记录

-define(MIN_RANK_NO, 3).                %% 能领取登顶排名奖励的最小排名

-define(MIN_FLOOR, 1).                  %% 最小层数

-define(ACT_STATUS_CLOSE, 0).
-define(ACT_STATUS_OPEN, 1).

-define(ACT_TYPE_BF, 0).                %% 本服活动
-define(ACT_TYPE_KF, 1).                %% 跨服活动

-define(SYNC_TYPE_ACT_STATUS, 1).       %% 同步活动状态
-define(SQL_VOID_FAM_GET0, <<"SELECT `rank`,`zone`,`rid`,`ser_num`,`name`,`floor`,`kills`,`combo`,`score`,`vip`,`sex`,`carrer`,`turn`,`vtype`,`svip`,`lv` FROM `void_fam_rank`">>).
-define(SQL_VOID_FAM_GET1, <<"SELECT `rank`,`zone`,`rid`,`ser_num`,`name`,`floor`,`kills`,`combo`,`score`,`vip`,`sex`,`carrer`,`turn`,`vtype`,`svip`,`lv` FROM `void_fam_kf_rank`">>).
-define(SQL_VOID_FAM_BATCH0, <<"REPLACE INTO void_fam_rank (`rank`,`zone`,`rid`,`ser_num`,`name`,`floor`,`kills`,`combo`,`score`,`vip`,`sex`,`carrer`,`turn`,`vtype`,`svip`,`lv`) VALUES ~ts">>).
-define(SQL_VOID_FAM_BATCH1, <<"REPLACE INTO void_fam_kf_rank (`rank`,`zone`,`rid`,`ser_num`,`name`,`floor`,`kills`,`combo`,`score`,`vip`,`sex`,`carrer`,`turn`,`vtype`,`svip`,`lv`) VALUES ~ts">>).
-define(SQL_VOID_FAM_RANK_LOG_BATCH0, <<"REPLACE INTO log_void_fam_rank (`zone_id`,`role_id`,`role_name`,`kf_stage`,`ser_id`,`ser_num`,`floor`,`score`,`rank`,`awards`,`time`) VALUES ~ts">>).
-define(SQL_VOID_FAM_RANK_LOG_BATCH1, <<"REPLACE INTO log_void_fam_rank_kf (`zone_id`,`role_id`,`role_name`,`kf_stage`,`ser_id`,`ser_num`,`floor`,`score`,`rank`,`awards`,`time`) VALUES ~ts">>).


%% 活动常量配置
-record(void_fam_cfg, {
    id = 0,
    key = "",
    val = 0,
    desc = ""
    }).

%% 层数配置
-record(void_fam_floor_cfg, {
    floor = 0,
    scene = 0,                          %% 场景id
    kf_scene = 0,                       %% 跨服场景id
    born_xy = [],                       %% 出生点坐标集[{x,y}]
    nkill  = 0,                         %% 新版本功能  此为需求击杀数
    reward = [],
    hscore = 0,                         %%心跳积分
    mult   = 0,                         %%经验倍数
    drate  = 0                          %%掉层概率
    }).

-record(status_void_fam, {
    status = 0,
    cls_type = 0,
    etime = 0,
    ref = [],
    add_ref = [],                      %%挂机定时器
    drop_ref = [0,0,0],                %%掉落定时器
    click = 0                          %%剩余宝箱数量
    }).

-record(role_info, {
    node = none,                        %% 玩家节点
    rank = 0,                           %% 排名
    role_id = 0,                        %% 玩家id
    zone = 0,                           %% 分区ID
    stage = 0,                          %% 分区当前阶段
    name = "",
    platform = "",                      %% 平台
    ser_id = 0,                         %% 服务器id
    ser_num = 0,                        %% 服号
    scene = 0,                          %% 场景id 不在活动场景则为0
    score = 0,                          %% 当前积分
    level = 0,
    awarded = [],                       %% 已领取
    kills = 0,                          %% 当前击杀数
    floor = 0,                          %% 当前层数
    mkills = 0,                         %% 累积击杀
    mfloor = 1,                         %% 最高层
    hp = 0,                             %% 当前血量
    combo = 0,                          %% 连杀数
    mcombo = 0,                         %% 最大连斩
    die_num = 0,                        %% 死亡次数
    sort = 0,                           %% 顶层抵达序列
    ref = [],                           %% 通关离开场景的定时器
    time = 0,                            %% 上一次进入时间  用来判断玩家是否第一次进入
    vip = 0,
    sex = 0,
    figure = 0
    }).